package com.ruoyi.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.domain.StandardInspectionItemRelation;
import com.ruoyi.domain.vo.DictDataVO;
import com.ruoyi.mapper.StandardInspectionItemRelationMapper;
import com.ruoyi.service.StandardInspectionItemRelationService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;


@Transactional
@Service
public class StandardInspectionItemRelationServiceImpl extends ServiceImpl<StandardInspectionItemRelationMapper, StandardInspectionItemRelation> implements StandardInspectionItemRelationService {

    @Autowired
    private StandardInspectionItemRelationMapper standardInspectionItemRelationMapper;

    @Override
    public List<DictDataVO> getByStandardId(Long standardId) {
        List<DictDataVO> list = standardInspectionItemRelationMapper.getListByStandardId(standardId);

        // 定义期望的排序关键字
        List<String> desiredOrder = Arrays.asList("sraif", "grfis", "trfis");

        // 使用流API对list进行排序
        List<DictDataVO> sortedList = new ArrayList<>();

        // 首先，创建一个映射表，键为dictValue，值为DictDataVO对象
        Map<String, DictDataVO> map = list.stream().collect(Collectors.toMap(DictDataVO::getDictValue, vo -> vo));

        // 然后，根据desiredOrder中的顺序从映射表中提取元素
        for (String order : desiredOrder) {
            if (map.containsKey(order)) {
                sortedList.add(map.get(order));
            }
        }
        return sortedList;
    }
}
